library(ggplot2)
data<-read.csv("Dis_GO_enrichment.csv",header=T)
attach(data)
ggplot (data,aes (x=Term,y=Gene_Count,fill=P_Value)) +geom_histogram(stat="identity")+ facet_grid(.~Category, scales='free_x', space='free_x',drop=T)+scale_fill_gradient("P-Value", low = "light blue", high = "blue")+
  xlab("GO terms")+ ylab ("Gene count")+ theme_bw() + 
  theme(
    axis.text.x=element_text(angle=50, hjust=1, size=4),
    strip.text.x=element_text (size=7.5),
    panel.grid.major=element_blank(),
    panel.grid.minor=element_blank()
  )

