#!/usr/bin/perl
use strict;
use warnings;
my $version="1.0 version";
use Getopt::Long;
my %opts;
GetOptions(\%opts,"o:s","i:s","q:s");
print "*************\n*$version*\n*************\n";
if ( !defined $opts{i} || !defined $opts{o} || !defined $opts{q}) {
	die "************************************************************************
	Usage: $0.pl
		-i: genome
		-q: HCE bed
		-o: HCE sequences
************************************************************************\n";
}

########################################################################################
my $out=$opts{o};
my $genome=$opts{i};
my $bed=$opts{q};

my $id; my %string;
open G,"$genome" or die $!;
while (<G>){
	chomp;
	if (/>(\S+)/){
		$id=$1;
	}else{
		$string{$id}.=$_;
	}
}

close G;

open BED,"$bed" or die $!;
open OUT,">$out" or die $!;
while (<BED>){
	chomp;
	my ($id,$start,$end)=split/\s+/,$_;
	my $length=$end-$start+1;
	my $str=substr($string{$id},$start-1,$length);
	print OUT ">$id\_$start\_$end\n$str\n";
}
close OUT;