#!/usr/bin/perl
use strict;
use warnings;
my $version="1.0 version";
use Getopt::Long;
my %opts;
GetOptions(\%opts,"o:s","i:s");
print "*************\n*$version*\n*************\n";
if ( !defined $opts{o} || !defined $opts{i} ) {
       	die "************************************************************************
       	Usage: $0
       		-i: augustus annotation
       		-o: augustus order annotation
************************************************************************\n";
}

my $augustus=$opts{i};
my $output=$opts{o};
open IN,"$augustus" or die $!;
open OUT,">$output" or die $!;
my $number;my $transcript;
my $transcript_t;my $number_gene; my $exon_t;my $exon;
while (<IN>){
	chomp;
	if (/^#/){
		print OUT "$_\n";
		next;
	}else{
		my ($scaf,$soft,$type,$start,$end,$score,$towards,$dot,$information) = split/\t/,$_;
		if ($type eq "gene"){
			$number_gene++;
			$number=sprintf ("%06d",$number_gene);
			print "$number\n";
			$information="ID=1.g$number;"."Name=augustus model m$number";
			print OUT "$scaf\t$soft\t$type\t$start\t$end\t$score\t$towards\t$dot\t$information\n";
		}elsif($type eq "transcript"){
			$transcript_t++;
			$transcript=sprintf("%06d",$transcript_t);
			$information="ID=1.m$transcript".";Parent=1.g$number";
			print OUT "$scaf\t$soft\tmRNA\t$start\t$end\t$score\t$towards\t$dot\t$information\n";
		}elsif($type eq "CDS"){
			$exon_t++;
			$exon=sprintf("%06d",$exon_t);
			my $information1="ID=1.e$exon;"."Parent=1.m$transcript";
			print OUT "$scaf\t$soft\texon\t$start\t$end\t$score\t$towards\t$dot\t$information1\n";
			
			my $information2="ID=cds_of_1.m$transcript;"."Parent=1.m$transcript";
			print OUT "$scaf\t$soft\tCDS\t$start\t$end\t$score\t$towards\t$dot\t$information2\n";
		}
		#print OUT "$scaf\t$soft\t$type\t$start\t$end\t$score\t$towards\t$dot\t$information\n";
	}
	
}
close IN;
close OUT;