#!/usr/bin/perl -w
#program: data_statistics.pl
#Description: This program calculate the heterozygosity(SNP and INDEL).
#Author: wangxin <wangxin@big.ac.cn>
#Date:   2011/12/6

use strict;
my $version="V2.00";
use Getopt::Std;
our($opt_i,$opt_l,$opt_o,$opt_h);
getopts('i:l:o:h');
if (!defined($opt_i)||!defined($opt_l)||!defined($opt_o)|| defined ($opt_h)) {
	&usage;
}
sub usage{
	print <<"USAGE";
       Program : $0
       Version : $version
       Contact : Wang xin <wangxin\@big.ac.cn>
       Usage :
		      $0  <-i Scaffold file> <-l Sequence length > <-o Output file> [option]
       options:
		          -i FILE scaffold or conting file
		          -l INT Sequence length,only longer than INT be calculated. [100]
		          -o FILE output file 
		          -h help
USAGE
	exit(1);
}
my $Time_Start =scalar (localtime(time()));
print "Start time is $Time_Start\n";
print "************...Running...************\n";
my $infile=$opt_i;
my $length=$opt_l;
my $output=$opt_o;
open F, $infile or die "can not find the file";
my(@key,%hash,@seqLengths,$GC_content,$key);
my $len=0;
my $m=0;
my $sum1=0;
my $sum=0;
my $count=0;
my $count2=0;

while(<F>){
	if ($_=~/^>(.*)/){
		$count++;
	push @key,$1;$key=$1;
	}else{
	chomp;
	$hash{$key}.=$_;}
}
close F;
my %hash_len;
foreach(@key){
	$hash_len{$_}=length($hash{$_});
	if (length($hash{$_})>= $length){
	$count2++;
	push @seqLengths,length($hash{$_});
	$len+=length($hash{$_});
	$sum+=$hash{$_}=~s/[gc]/[gc]/gi;
	$sum1+=$hash{$_}=~s/[Nn]/[Nn]/gi;
	}

}
$GC_content=sprintf "%.2f",100*$sum/($len-$sum1);

my ($mean,$i,$N50,$N90);
my $N50count = 0;
my $N90count= 0;
$mean=sprintf "%d",$len/$count2;
$i=sprintf "%d",$count2/2;
$i--;

@seqLengths=reverse sort{$a<=>$b}@seqLengths;

my @seqLengths1=@seqLengths;
my $frac_covered = $len;

$N50=$seqLengths[0];

while($frac_covered > $len*0.5){
        $N50 =shift(@seqLengths1);
        $N50count++;$N90count++;
        $frac_covered -=$N50;
}

$N90=$N50;
while($frac_covered > $len*0.1) {
        $N90 = shift(@seqLengths1);
        $N90count++;
        $frac_covered -= $N90;
}


open O ,">>$output" or die "$!";
print O "id\tTotal number\tTotal number of filter\tTotal length\tLongest length\tShortest Length\tMean length\tMedian Length\tN50\tN50_count\tN90\tN90_count\tTotal GC\tGC count(%)\n";
print O "${infile}\t$count\t$count2\t$len\t$seqLengths[0]\t$seqLengths[-1]\t$mean\t$seqLengths[$i]\t$N50\t$N50count\t$N90\t$N90count\t$sum\t$GC_content\%\n";
print O "N50count:$N50count\nN90cout:$N90count\tTotal_number:$i\tTotal_number_of_filter:$count2\n";
#my $a;my $b;
#for (my $i=1;$i<100 ;$i++) {
#	my $count1=0;
#        $a=100*$i;
#	 $b=100*($i+1);
#	 for my $id(@key) {
#		 next unless ($hash_len{$id}>=$a && $hash_len{$id}< $b);
#		 $count1++;   
#	 }
 #   print O "$a-$b\t$count1\n";
#}
my $c;my $d;
for (my $n=1;$n<1000 ;$n++) {
	my $count2=0;
   $c=1000*$n;
	 $d=1000*($n+1);
	 for my $id1(@key) {
		 next unless ($hash_len{$id1}>=$c && $hash_len{$id1}< $d);
		 $count2++;   
	 }
    print O "$c-$d\t$count2\n";
}
#my $e;my $f;
#for (my $n=1;$n<10 ;$n++) {
#	my $count3=0;
#    $e=10000*$n;
#	 $f=10000*($n+1);
#	 for my $id2(@key) {
#		 next unless ($hash_len{$id2}>=$e && $hash_len{$id2}< $f);
#		 $count3++;   
#	 }
 #   print O "$e-$f\t$count3\n";
#}
my $count4=0;
 for my $id3(@key) {
		 next unless ($hash_len{$id3}>=1000000);
		 $count4++;   
	 }
    print O ">=1000000\t$count4\n";
close O;
#my $Time_Stop =scalar (localtime(time())); 
#print "Stop time is $Time_Stop\n";
#print "************...Fishing...************\n";
