#!/usr/bin/perl
use strict;
use warnings;
my $version="1.0 version";
use Getopt::Long;
my %opts;
GetOptions(\%opts,"o:s","i:s","n:s","g:s");
print "*************\n*$version*\n*************\n";
if ( !defined $opts{o} || !defined $opts{i} || !defined $opts{n} ||!defined $opts{g}) {
       	die "************************************************************************
       	Usage: $0
				-g: original gff file
       		-i: asupport annotation
				-n: no support information
       		-o: final gff file
************************************************************************\n";
}

my $gff=$opts{g};
my $noinform=$opts{n};
my $support=$opts{i};
my $output=$opts{o};


my %unsupport;
open NO,"$noinform" or die $!;
while (<NO>){
	chomp;
	$unsupport{$_}++;
}
close NO;
my %sup;
open SUP,"$support" or die $!;
while (<SUP>){
	chomp;
	$sup{$_}++;
}
close SUP;
open IN,"$gff" or die $!;
open OUT,">$output" or die $!;
my $number;my $transcript;
my %ann;
while (<IN>){
	chomp;
	next if (/^$/);
	if (/^#/){
		print OUT "$_\n";
		next;
	}else{
		my $seq=$_;
		my ($scaf,$soft,$type,$start,$end,$score,$towards,$dot,$information) = split/\t/,$_;
		while ($information=~/([^\s;]+)=([^\s;]+)/g){
			$ann{$1}=$2;
		}
		if ($type eq "gene" || $type eq "mRNA"){
			my $name=$ann{ID};
			$name=~s/TU/model/;
			if(!exists $unsupport{$name} && exists $sup{$name} ){
				print OUT "$seq\n";
			}else{
				print "$seq\n";
			}
		}else{
			my $id=$ann{Parent};
			if(!exists $unsupport{$id} && exists $sup{$id} ){
				print OUT "$seq\n";
			}else{
				print "$seq\n";
			}
		}
		#print OUT "$scaf\t$soft\t$type\t$start\t$end\t$score\t$towards\t$dot\t$information\n";
	}
	
}
close IN;
close OUT;