#!/usr/bin/perl
#date :June 27th 2015
#author:Xin Wang
#discription: transfer the gene family group format into cafe input , based on all annotation information;
use strict;
use warnings;



use Bio::Seq;
use Bio::SeqIO;


my $version="1.0 version";
use Getopt::Long;
my %opts;
GetOptions(\%opts,"i:s","o:s","f:s");
print "*************\n*$version*\n*************\n";
if (!defined $opts{i} || !defined $opts{f} || !defined $opts{o}) {
	die "************************************************************************
	Usage: group_annotation_for_cafe.pl -i group -f annotation -o gene_family_annotation 
************************************************************************\n";
}

my $group=$opts{i};
my $annot=$opts{f};
my $output=$opts{o};


open AN,"$annot" or die $!;
my $form_des;my $form_GO;
my %GO_num;my %Pfam;
while (<AN>){
	chomp;
		my @array=split/\t/,$_;
		next if $#array<13;
		my $n=0;
		my ($id,$pid,$length,$type,$accession,$description,$start,$stop,$score,$status,$date,$interpro,$interpro_annote,$GO)=@array;
		if ($type eq 'Pfam'){
			$Pfam{$id}->{$description}++;
			#$Pfam{$id}.=($description ne "$form_des")?$description.";":'';
			#$GO_num{$id}.=($GO ne "$form_GO" )?$GO."|":'';
			#$form_des=$description;
			#$form_GO=$GO;
			#print "$Pfam{$id}\n";
		}
}
my %PFAM_finnal;
foreach my $id (keys %Pfam){
	foreach my $des(keys %{$Pfam{$id}}){
		$PFAM_finnal{$id}.=$des.";";
	}
	

}
close AN;
open GROUP,"$group"  or die $!;
open OUT,">$output" or die $!;
my @species=("jgi","aip","amp","dis","adi","spis","gnl");
my $example=join "\t",@species;
print OUT "Description\tID\tJGI\tAIP\tAMP\tDIS\tADI\tSPIS\tGNL\n";
while (<GROUP>){
	chomp;
	my @array=split/\s+/,$_;
	my $id=(split/:/,$array[0])[0];
#	print OUT "$array[0]
#		foreach my $num(1..$#array){
#			print OUT "$GO_num{$array[$num]}|" if ($array[$num] =~/amp/ && exists $GO_num{$array[$num]});
#			print OUT "$GO_num{$array[$num]}|" if ($array[$num]=~/dis/ && exists $GO_num{$array[$num]});
#		}
#		print OUT "\t";
	my %num;my @annotation;my @info;
	foreach my $n(1..$#array){
		if (exists $PFAM_finnal{$array[$n]}){
			@info=split/;/,$PFAM_finnal{$array[$n]};
			push @annotation,@info;
		}
		#push @annotation,$PFAM_finnal{$array[$n]} if (exists $PFAM_finnal{$array[$n]});
		my ($type,$scaf)=split/\|/,$array[$n];
		$num{$type}++;
#			print OUT "$Pfam{$array[$num]};" if ($array[$num] =~/amp/ && exists $Pfam{$array[$num]});
#			print OUT "$Pfam{$array[$num]};" if ($array[$num]=~/dis/ && exists $Pfam{$array[$num]});
	}
		#my %sort;
		#@sort{@annotation}=();
		#my @uniq_annotation=sort keys %sort;
		## ȥظעͣ
	my %count;my $annotation_information;my @uniq_annot;
	if ($#annotation>=0){
		@uniq_annot=grep {++$count{$_}<2;} @annotation ;
		$annotation_information=join ";",@uniq_annot;
	}else {
		$annotation_information="NA";
	}
		
	foreach my $class(@species){
		$num{$class}=0 if (!exists $num{$class});
	}
	print OUT "$annotation_information\t$id\t$num{jgi}\t$num{aip}\t$num{amp}\t$num{dis}\t$num{adi}\t$num{spis}\t$num{gnl}\n";
}
close OUT;
close GROUP;
