#!/usr/bin/perl
use strict;
use warnings;
my $version="1.0 version";
use Getopt::Long;
my %opts;
GetOptions(\%opts,"o:s","i:s","h:s");
print "*************\n*$version*\n*************\n";
if ( !defined $opts{i} || !defined $opts{o} || defined $opts{h}) {
	die "************************************************************************
	Usage: $0.pl
		-i: HCE sequence
		-o: HCE align sequences across six species
		-h: help
************************************************************************\n";
}

########################################################################################
my $out=$opts{o};
my $genome=$opts{i};
#my $bed=$opts{q};

my $id; my %string; my $name; my %m;my %hash;
open G,"$genome" or die $!;
while (<G>){
	chomp;
	if (/>(\S+)/){
		$name=$1;
		my($num,$identity,$id)=split/\|/,$1;
		my $spe=(split/\-/,$id)[0];
		$hash{$num}->{$spe}++;
		$m{$num}->{$name}++;
		
	}else{
		$string{$name}.=$_;
	}
}
close G;
my @array=("aip","dis","amp","jgi","adi","spi");
open OUT,">$out" or die $!;
foreach my $num(sort keys %m){
	my $n=0;
	foreach my $spe(@array){
		$n++ if (exists $hash{$num}->{$spe});
	}
	if ($n==6){
		print "$num\n";
		foreach my $name (sort keys %{$m{$num}}){
			print OUT ">$name\n$string{$name}\n";
		}
	}
}
close OUT;