#!/usr/bin/perl
# Copyright (c) BIG 2010
# Author:Liu Kan <liukan@big.ac.cn>
# Date: 201042710:49:48
# Description: This program cut the raw fasta file into smaller contig
#use strict;
#use warnings;
use Getopt::Long;
my $ver="1.0"; #version
my %opts;
GetOptions(\%opts,"i:s","o:s","e:s","n:s","h!");
my $usage=<<"USAGE";
       Program : $0
       Version : $ver
       Contact : Liu Kan <liukan\@big.ac.cn>
       Usage : $0 -i input fasta -n 1 -o output fasta
                  -h Display this usage information
USAGE
die $usage if (!defined $opts{i} || !defined $opts{o} || !defined $opts{n} || $opts{h});
my $Time_Start =scalar (localtime(time())); 
print "Start time is $Time_Start\n";
print "*********************************
Running.....\n*********************************\n";
my $input=$opts{i};
my $nn=$opts{n};
my $output=$opts{o};
my ($key,%hash);
open (IN,"$input")||die "$!";
while (<IN>)
{
	chomp;$_=~s/\r//g;
	if ($_ eq "")
	{
		next;
	}
	if (/(^>\S+)/)
	{
		$key=$1;
	}
	else
	{
		$hash{$key}.=$_;
	}
}
close (IN);
print "Read the raw fasta done !\n";
my $name=1;

open (OUT,">$opts{o}.scaf2contig.fasta")||die "$!";

$read=0;
foreach my $a (keys %hash)
{
	my @array="";
	if(my @array=split (/N{$nn,}/,$hash{$a}))
	# if(my @array=split (/N{10,}/,$hash{$a}))    # ڵ10űָ
	{
		for (my $b=0;$b<=$#array;$b++)
		{
			my $number=$b+1;
			$read++;
			$len=length($array[$b]);
			$len{$len}++;
			@N="";
			$n=0;
			if(@N=$array[$b]=~/N/gi)
			{
				$n=$#N+1;
			}
			$N{$n}++;
			my $name=$a."_".$number." "."length"." ".$len." "."N".$n;
			print OUT "$name\n";
			print OUT "$array[$b]\n";
		}
	}
	else
	{
		$len=length($hash{$a});
		$name=$a." "."length"." ".$len." "."ctg";
		print OUT "$name\n";
		print OUT "$hash{$a}\n";
	}
}
print "reads number\t$read\n";
print "N number distribution of reads\n";
@N=keys(%N);
@N=sort{$a<=>$b}@N;
for($i=0;$i<=$#N;$i++)
{
	$ii=$N[$i];
	print "$i\t$ii\t$N{$ii}\n";
}
print "length distribution of contig reads\n";
@N="";
@N=keys(%len);
@N=sort{$a<=>$b}@N;
for($i=0;$i<=$#N;$i++)
{
	$ii=$N[$i];
	print "$i\t$ii\t$len{$ii}\n";
}
my $Time_Stop =scalar (localtime(time())); 
print "Stop time is $Time_Stop\n";
print "*********************************
Jobs Done!\n*********************************\n";
