#!/usr/bin/perl -w
#program: scaffold_gap.pl
#Description: 
#Author: Wang Sen <wangsen@big.ac.cn>
#Date:   2013/11/29

use strict;
my $version="V1.00";
use Getopt::Long;
my %opts;
GetOptions( \%opts , "i:s" ,"o:s" ,"h!" );
if ( !defined $opts{i}||!defined $opts{o}|| defined $opts{h} ){
	&usage;
}
sub usage{
	print <<"USAGE";
       Program : scaffold_gap.pl
       Version : $version
       Contact : Wang Sen <wangsen\@big.ac.cn>
       Usage :
		scaffold_gap.pl <-i infile> <-o output> 
       options:
		 -i FILE scaffold file
		 -o FILE output file
		 -h      Display this usage information
USAGE
	exit(1);
}

my $Time_Start =scalar (localtime(time()));
print "Start time is $Time_Start\n";
print "************...Running...************\n";
my $infile = $opts{i};
my $output = $opts{o};
open IN, "$infile" or die $!;
open OUT, ">$output" or die $!;
my %seq;my $key;
open IN,"$infile" or die $!;
while(<IN>){
	chomp;s/\r//g;
	next if ($_ eq '');
	if (/^>(.+)/){
		$key=$1;
	}else{	
		$seq{$key}.=$_;
	}
}
close IN;
open OUT,">$output" or die "$!";
my %gap;
my $count=0;my $N_num=0;my $toal_size=0;my $gapL=0;
for my $id(keys %seq) {
	my $seq=$seq{$id};$seq=~s/\s+//g;
	#next unless ($seq=~/(N+)/gi);
	$count++;
	my $pos=0;
	while ($seq=~/(N+)/gi) {
		my $N_seq=$1;
		$N_num++;
		my $star=index ($seq,$N_seq,$pos) + 1;
		my $size=length $N_seq;
 		$pos=$star + $size;
		my $end=$star + $size-1;
		$toal_size+=$size;
		$gap{"$id\t$star\t$end"}=$size;
		print OUT "$id\t$star\t$end\t$size\t$pos\n";
	}
}
close OUT;
open OUT,">${output}.stat" or die "$!";
my @gap_size=sort {$gap{$b} <=> $gap{$a}} keys %gap;
my $ave_size=int($toal_size/$N_num);
print OUT "num\tTotal size\tNum\tMax size\tMin size\tAve size\n";
print OUT"$count\t$toal_size\t$N_num\t$gap{$gap_size[0]}\t$gap{$gap_size[-1]}\t$ave_size\n";
my $n=0;
for my $id1(keys %gap) {
	next unless ($gap{$id1}<10);
	$n++;
	delete $gap{$id1};
}
print OUT "0-10\t$n\n";

for my $d(10,100,1000,10000) {
	for (my $i=1;$i<=9 ;$i++) {
		print OUT "";
		$n=0;
		for my $id(keys %gap) {
			next unless ( $gap{$id}>=$i*$d &&$gap{$id}<($i+1)*$d);
			$n++;
			delete $gap{$id};
		}
		print OUT $i*$d,"-",($i+1)*$d,"\t$n\n";
	}
}
$n=0;
for my $id(keys %gap) {
	next unless ($gap{$id}>=100000);
	$n++;
}
print OUT ">=100000\t$n\n";
close OUT;
my $Time_Stop =scalar (localtime(time())); 
print "Stop time is $Time_Stop\n";
print "************...Fishing...************\n";