#!/usr/bin/perl
use strict;
use warnings;
my $version="1.0 version";
use Getopt::Long;
my %opts;
GetOptions(\%opts,"o:s","i:s");
print "*************\n*$version*\n*************\n";
if ( !defined $opts{o}|| !defined $opts{i} ) {
	die "************************************************************************
	Usage: $0.pl
		-i: duplication list (blast result top2)
		-o: the ratio with duplication list
************************************************************************\n";
}

########################################################################################
my $out=$opts{o};
my $duplication=$opts{i};
my %hash;


open IN,"$duplication" or die $!;
open OUT,">$out" or die $!;
my $seq;	my $score;
while (<IN>){
	chomp;
	my $information=$_;
	my ($id1,$id2,$bitscore)=(split/\t/,$_)[0,1,12];
	if ($id1 eq $id2 && $id1 ne $seq){
		$score=$bitscore;
		$seq=$id2;
		print "$information\n";
	}elsif($id1 ne $id2 && $id1 eq $seq){
		my $dup_score=$bitscore;
		my $coverage= sprintf "%.3f",$dup_score/$score;
		$seq=$id2;
		print OUT "$_\t$coverage\n";
	}
}
close IN;
close OUT;
