#!/usr/bin/perl
#author:wangxin
#email:wangxin@big.ac.cn
#time:2012.8.16
#function:establish a hash of mapping result in different gene site via SAM.
#			and from the information of GFF,by means of hash message search different gene(CDS,exon)'s coverage.

use strict;
use warnings;
my $version="1.0 version";
use Getopt::Long;
my %opts;
GetOptions(\%opts,"s:s","r:s","o:s");
print "*************\n*$version*\n*************\n";
if ( !defined $opts{r}|| !defined $opts{s}||!defined $opts{o}) {
	die "************************************************************************
	Usage: sam2coverage.pl 
		-s: sam file
		-r: fasta file
		-o: out file
************************************************************************\n";
}
my %hash;
my $chr;
open (SAM,"<$opts{s}") or die "can't open file :$opts{s}";
while (<SAM>) {
	chomp;
	#SRR063667.1     99      Chr8    1493049 1       30M     =       1493181 162     GCTGAGAGTTGCTCNGGATACATATTTCAA  77777777777777!777777777777777  AS:i:-1 XS:i:-1 XN:i:0  XM:i:1  XO:
	#SRR063666.76    177     Chr7    13478304        0       4M3I27M Chr4    3192210 0       TGACAATTTTCTGGGCTTGTCACAAGCACTCTCT      6/66888889888898888888888999888899      AS:i:-18
	my @list;	
	next if /^\@/;
	next if /^\s+/;
	@list = split/\t/;
	next if ($list[2]!~/\w+/);
	my $offset=0;
	my $vn;
	my $vt;
	while ($list[5]=~/(\d+)([A-Z])/g){
		$vn=$1;$vt=$2;
		for (1..$vn){
			$hash{$list[2]}->{$list[3]+$offset}++ if ($vt eq 'M');
			$offset++ if ($vt ne 'I');
		}
	}
}

close SAM;







open TIGR, "<$opts{r}" or die "Can't open file:$opts{r}";
open OUT,">$opts{o}"or die"can not create file :$opts{o}";
my %number;
my $length=0;
my $genome_coverage;
my $ch;
my $n;
while (<TIGR>) {
	chomp;
	
	## >chr1
	## NNNAAATGCGTAGH
	next if /^\s+/;
	if (/^\>(\S+)/) {

		$ch=$1;
	}
	if (/\S+/) {
		$n=length $_;
		$number{$ch}+=$n;
		$length+=$n;
	}
}

my $coverage;
my $pop;
foreach $ch (keys %hash) {
	print OUT "$ch length is $number{$ch}\n";
	foreach $pop(1..$number{$ch}+1) {

		if ( ($hash{$ch}->{$pop})>2) {
			$coverage++;
		}
	}
}
$genome_coverage=$coverage/$length;
print OUT  "genome's coverage is $genome_coverage!\n";

close TIGR;
close OUT;
